#!/usr/bin/env python

from math import *
from cmath import *
from Numeric import *
from gist import *
from curve import Curve
from graph2d import *
from LCR import dataread, z_input, paws, argument, norm

#gammas = zeros(len(freqs), Complex)
#gammas = re_s11s+1j*im_s11s

if __name__ == '__main__':

    #BRASS SELF AT 300K FOR 12T:    
 
    Self = ['L', 's', 84e-9] # was 85e-9
    Loss = ['R', 's', 0.8] # was 0.8 
    Cbrass = ['C', 'p', 0.6e-12]  # was 0.6e-12C
    fin300 = ['X', 't', 50.0, 0.020, 2.0e8, 0.036] #VAlues wtih fit databuisson
    Circuit1 = [Self, Loss, Cbrass, fin300]

    fs = span(140e6,780e6, 1001)
    zs = z_input(Circuit1, fs)
    gs = (zs-50.0)/(zs+50.0)
    fs = 1.0e-9*fs

    freqs, res11s, ims11s = dataread("self300K.dat") 

    curve = Curve(x=gs.real, y=gs.imaginary, color = 'red')
    curve1 = Curve(x=res11s, y=ims11s)
    titles = ['regamma','self300K', 'imgamma', '']
    graph = Graph2d([curve, curve1],
                    titles= titles,
                    axis_limits=[[0,1.0],[0,1.0]],
                    style = "boxed.gs")

    graph.plot()
#    paws()
    winkill()

##      #COAXIAL LINE AT 4K:

##      Short =  ['S', 's']
##      Room4 = ['X', 't', 50.0, 0.044, 2.0e8, 1.17] #autre ligne 1.150 


##      Circuit2 = [Short, Room4]

##      fs= span(140e6,780e6, 1001)
##      zs = z_input(Circuit2, fs)
##      gs = (zs-50.0)/(zs+50.0)
##      fs = 1.0e-9*fs

##      freqs, res11s, ims11s = dataread("shortroom4.dat") 

##      curve1 = Curve(x=fs, y=abs(gs), color ='red')
##      curve2 = Curve(x=fs, y=argument(gs), color ='green')
##      curve3 = Curve(x=freqs, y=norm(ims11s,res11s))
##      curve4 = Curve(x=freqs, y=arctan(ims11s/res11s))
##      titles = ['freq','coaxe4K', 'absgamma', '']
##      graph = Graph2d([curve1,
##                       curve2,
##                       curve3,
##                       curve4],
##                       titles = titles,
##                       axis_limits=[[0.3,0.4],[-1.6,1.6]],
##                       style = "boxed.gs")

##      graph.plot()
##      paws()

    #RESONANT CIRCUIT EXPECTED AT 4K:

     
    Self = ['L', 's', 84e-9]
    Loss = ['R', 's',0.7]
    Cbrass = ['C', 'p', 0.60e-12]
    Room4 = ['X', 't', 50.0, 0.044, 2.0e8, 1.21]
    fin4 = ['X', 't', 50.0, 0.020, 2.0e8, 0.036]
    Cp = ['C', 'p',  2.235e-12] # for 2.18pF size Cp: 7*1.86 mm::7*2 mm sur gravure
    Cs = ['C', 's', 0.33e-12]  # for 0.23pF size Cs: 1*1.5 mm::1*2 mm sur gravure
    Circuit3 = [Self, Loss, Cp, Cs, Room4]

    fs = span(140e6,780e6, 1001)
    zs = z_input(Circuit3, fs)
    gs = (zs-50.0)/(zs+50.0)
    fs = 1.0e-9*fs

    winkill()

    curve2 = Curve(x=fs, y=abs(gs), color ='red')
    titles = ['freq','circ4Kexpected', 'absgamma', '']
    graph = Graph2d([curve2],
                    titles = titles,
                    axis_limits = [[0.30,0.400],[0,1.0]],
                    style = "boxed.gs")

    graph.plot()
    paws()
    graph.plot()
    
  
    #RESONANT CIRCUIT MESURED AT 4K
    Self = ['L', 's', 84e-9] # was 64.0e-9 for paper QFS
    Loss = ['R', 's', 0.7] # was 0.6
    Cbrass = ['C', 'p', 0.60e-12]  # was 0.28e-12C
    Room4 = ['X', 't', 50.0, 0.044, 2.0e8, 1.5]#was 1.21
    fin4 = ['X', 't', 50.0, 0.020, 2.0e8, 0.036]
    supra = ['X', 't', 53.0, 0.062, 2.355e8, 0.50]
    Cp = ['C', 'p',  2.235e-12] #was 2.235
    Cs = ['C', 's', 0.33e-12] #was 0.33
    Circuit4 = [Self, Loss, Cp, Cs, Room4]

    fs = span(130e6,770e6, 4001)
    zs = z_input(Circuit4, fs)
    gs = (zs-50.0)/(zs+50.0)
    fs = 1.0e-9*fs

    winkill()
    freqs, res11s, ims11s = dataread("circ4K.dat") 
    hardcopy = 'circ4.ps'
    curve3 = Curve(x=fs, y=abs(gs), color ='red')
    curve4 = Curve(x=freqs, y=norm(ims11s,res11s))
    titles = ['freq','circ4Kmesured', 'absgamma', '']
    graph = Graph2d([curve3, curve4],
                    titles= titles,
                    hardcopy = hardcopy,
                    axis_limits=[[0.320,0.360],[0,1.0]],
                    style = "boxed.gs")

#    graph.plot()
#    paws()
#    graph.plot()

    winkill()

    freqs, res11s, ims11s = dataread("circ4K.dat") 

    curve5 = Curve(x=gs.real, y=gs.imaginary, color ='red')
    curve6 = Curve(x=res11s, y=ims11s)
    titles = ['Regamma','circ4Kmesured', 'Imgamma', '']
    graph = Graph2d([curve5, curve6],
                     titles= titles,
                     axis_limits=[[-1.0,1.0],[-1.0,1.0]],
                     style = "boxed.gs")

#    graph.plot()
#    paws()
#    graph.plot()
   
  
   #RESONANT CIRCUIT MESURED AT 300K

    Self = ['L', 's', 84e-9] # was 64.0e-9 for paper QFS
    Loss = ['R', 's', 6.0] # was 1.7 for paper QFS
    Cbrass = ['C', 'p', 0.60e-12]  # was 0.28e-12C
    fin300 = ['X', 't', 50.0, 0.020, 2.0e8, 0.036]
    Room300 = ['X', 't', 50.0, 0.05, 2.0e8, 2.0] #length was 1.21, losses was                                                     0.05
    Cp = ['C', 'p',  2.34e-12]
    Cs = ['C', 's', 0.5e-12]
    Circuit5 = [Self, Loss, Cp, Cs, fin300,Room300]

    fs = span(140e6,780e6, 1001)
    zs = z_input(Circuit5, fs)
    gs = (zs-50.0)/(zs+50.0)
    fs = 1.0e-9*fs

    winkill()

    freqs, res11s, ims11s = dataread("circ300K.dat") 
    hardcopy = 'circ300.ps'

    curve7 = Curve(x=fs, y=abs(gs), color ='red')
    curve8 = Curve(x=freqs, y=norm(ims11s,res11s))
    titles = ['freq','circ300K', 'absgamma', '']
    graph = Graph2d([curve7, curve8],
                    hardcopy = hardcopy,
                    titles= titles,
                    axis_limits=[[0.14,0.78],[0.0,1.0]],
                    style = "boxed.gs")
#    graph.plot()
#    paws()
#    graph.plot()

    #NEW RESONANT CIRCUIT TYPE EXPECTED AT 4K:

     
    Self = ['L', 's', 84e-9]
    Loss = ['R', 's',0.7]
    Room4 = ['X', 't', 50.0, 0.044, 2.0e8, 1.21]
    Cp = ['C', 'p',  75.0e-12] # for 2.18pF size Cp: 7*1.86 mm::7*2 mm sur gravure
    Cs = ['C', 's', 2.55e-12]  # for 0.23pF size Cs: 1*1.5 mm::1*2 mm sur gravure
    Apara = ['A', 'p', [Self, Loss, Cs]]
    Circuit6 = [Cp, Apara, Room4]

    fs = span(200e6,500e6, 1001)
    zs = z_input(Circuit6, fs)
    gs = (zs-50.0)/(zs+50.0)
    fs = 1.0e-9*fs

    winkill()

    curve9 = Curve(x=fs, y=abs(gs), color ='green')
    titles = ['freq','NEWcirc4Kexpected', 'absgamma', '']
    graph = Graph2d([curve9],
                    titles = titles,
                    hardcopy = 'testnewcirc.ps',
                    axis_limits = [[0.300,0.400],[0,1.0]],
                    style = "boxed.gs")

    graph.plot()
    paws()
    graph.plot()
    
    winkill()

    graph = Graph2d ([curve9, curve2],
                     axis_limits = [[0.300, 0.400], [0.0, 1.0]],
                     style = "boxed.gs")
    graph.plot()
    paws()
    graph.plot()
    
  
    print "Yoopie"










